=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --parallel --buildsystem=cmake

override_dh_auto_clean:
	rm -rf apidoc
	dh_auto_clean

override_dh_auto_configure:
	dh_auto_configure -- \
	 -DLIB_INSTALL_DIR=lib/$(DEB_HOST_MULTIARCH) \
	 -DUSE_STATIC_MBEDTLS_LIBRARY=OFF \
	 -DUSE_SHARED_MBEDTLS_LIBRARY=ON

override_dh_auto_build:
	dh_auto_build -- all apidoc

override_dh_installdocs:
	dh_installdocs -X.md5
