=== debian/control ===
--- 
+++ 
@@ -3,11 +3,8 @@
 Priority: optional
 Maintainer: James Cowgill <james410@cowgill.org.uk>
 Standards-Version: 3.9.6
-Build-Depends:
- cmake,
- debhelper (>= 9),
- doxygen,
- graphviz
+Build-Depends: cmake, debhelper (>= 9)
+Build-Depends-Indep: doxygen, graphviz
 Homepage: https://tls.mbed.org/
 Vcs-Git: git://anonscm.debian.org/collab-maint/mbedtls.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/mbedtls.git
