=== debian/rules ===
--- 
+++ 
@@ -15,7 +15,7 @@
 	 -DUSE_STATIC_MBEDTLS_LIBRARY=OFF \
 	 -DUSE_SHARED_MBEDTLS_LIBRARY=ON
 
-override_dh_auto_build:
+override_dh_auto_build-indep:
 	dh_auto_build -- all apidoc
 
 override_dh_installdocs:
