## mbedtls 2.2.1

=== debian/changelog ===
mbedtls (2.2.1-3) unstable; urgency=medium

  * debian/control:
    - Use my debian.org email address.
    - Bump standards to 3.9.8 (no changes).
  * debian/patches:
    - Add 02_x32.patch to fix FTBFS on x32.
  * debian/rules:
    - Enable all hardening options.

 -- James Cowgill <jcowgill@debian.org>  Wed, 18 May 2016 17:21:39 +0100

mbedtls (2.2.1-2) unstable; urgency=medium

  * debian/control:
    - Use secure Vcs-Git URL.
  * debian/libmbedcrypto0.lintian-override:
    - Drop now that lintian itself has been fixed.
  * debian/rules:
    - Don't build arch:any packages in arch:all build.
  * debian/*.symbols:
    - Drop unnecessary patch level from symbol file versions.
  * debian/tests:
    - Add an autopkgtest which compiles and runs the selftest program.

 -- James Cowgill <james410@cowgill.org.uk>  Sat, 16 Jan 2016 00:12:49 +0000

mbedtls (2.2.1-1) unstable; urgency=medium

  * New upstream version.

 -- James Cowgill <james410@cowgill.org.uk>  Tue, 05 Jan 2016 13:15:33 +0000
