=== debian/control ===
--- 
+++ 
@@ -1,13 +1,14 @@
 Source: mbedtls
 Section: libs
 Priority: optional
-Maintainer: James Cowgill <james410@cowgill.org.uk>
-Standards-Version: 3.9.6
+Maintainer: James Cowgill <jcowgill@debian.org>
+Standards-Version: 3.9.8
 Build-Depends: cmake, debhelper (>= 9)
 Build-Depends-Indep: doxygen, graphviz
 Homepage: https://tls.mbed.org/
-Vcs-Git: git://anonscm.debian.org/collab-maint/mbedtls.git
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/mbedtls.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/mbedtls.git
+Testsuite: autopkgtest
 
 Package: libmbedtls-dev
 Architecture: any
