=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,6 @@
 #!/usr/bin/make -f
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
@@ -16,7 +18,10 @@
 	 -DUSE_SHARED_MBEDTLS_LIBRARY=ON
 
 override_dh_auto_build-indep:
-	dh_auto_build -- all apidoc
+	dh_auto_build -- apidoc
+
+override_dh_auto_test-indep:
+override_dh_auto_install-indep:
 
 override_dh_installdocs:
 	dh_installdocs -X.md5
